<?php
/*
Plugin Name: WP Tweet Button
Version: 1.9.4.1
Plugin URI: http://0xtc.com/2010/08/13/twitters-tweet-button-for-wordpress.xhtml
Description: The WordPress implementation of the official Twitter Tweet Button.
Contributors: 0xtc
Author: Tanin Ehrami
Author URI: http://0xtc.com
Stable tag: trunk
Text Domain: wp-tweet-button
Domain Path: /lang
*/

/*
	Hooks:
#	wp_tweet_button_long_url 
	(string:url)
	Use this hook to manipulate the value of the permalink that has about to be used for shortening and for counturl

#	wp_tweet_button_url
	(string:url)
	Use this hook to manipulate the value of the shorturl that has about to be used to tweet with.

#	wp_tweet_button
	(string:html)
	Use this hook to manipulate the generated button html code.
*/

// getting classy with it...
class wpTweetButton {
	var $optionsname = 'wp_tweet_button';
	var $txtdom = 'wp-tweet-button';
	var $readyState = false;
	var $options = array(
			'tw_hook_prio'=> '75',
			'tw_where'=> 'before',
			'tw_text'=>'entry_title',
			'tw_text_format'=>'VIA',
			'tw_text_custom'=>'',
			'tw_flush_cache'=>'',
			'tw_url_shortener'=>'none',
			'tw_url_shortener_snip_user'=>'',
			'tw_url_shortener_snip_key'=>'',
			'tw_url_shortener_cligs_key'=>'',
			'tw_url_shortener_super_user'=>'',
			'tw_url_shortener_super_key'=>'',
			'tw_url_shortener_bitly_user'=>'',
			'tw_url_shortener_bitly_key'=>'',
			'tw_url_shortener_tinyarrow_user'=>'',
			'tw_url_samecount'=>'1',
			'tw_rel_meta'=>'',
			'tw_via'=>'',
			'tw_ga_code'=>'',
			'tw_align'=>'none',
			'tw_rec'=>'',
			'tw_rec_desc'=>'',
			'tw_lang'=>'en',
			'tw_style'=> '',
			'tw_style_c'=> '',
			'tw_count'=> 'horizontal',
			'tw_display_single'=> '1',
			'tw_display_archive'=> '1',
			'tw_display_search'=> '1',
			'tw_display_excerpt'=> '1',
			'tw_display_feed'=> '1',
			'tw_display_page'=> '1',
			'tw_display_front'=> '1',
			'tw_display_mobile'=>'',
			'tw_ex_after_home'=>'',
			'tw_bwdata_attr'=> '',
			'tw_config_ver'=>''
		);
	var $boolops = array(
			'tw_display_single',
			'tw_display_search',
			'tw_ex_after_home',
			'tw_display_archive',
			'tw_display_page',
			'tw_display_front',
			'tw_display_excerpt',
			'tw_display_feed',
			'tw_display_mobile',
			'tw_bwdata_attr',
			'tw_url_samecount'
		);
		
	function init() {
		$this->tw_readoptions();
	}

	function tw_writeoptions(){
		update_option($this->optionsname, $this->options);
	}

	function tw_updateoptions() {
		if( isset($_POST['tw_where']) ) {
			$new_options = $_POST;
			$bool_options = $this->boolops;
			foreach($bool_options as $key) {
				$new_options[$key] = $new_options[$key] ? '1' : '';
			}
			$new_options['tw_via'] = $this->tw_sanitize_username($new_options['tw_via']);
			$new_options['tw_rec'] = $this->tw_sanitize_username($new_options['tw_rec']);

			foreach($this->options as $key => $option) {
				$this->options[$key] = $new_options[$key];
			}			
			$this->tw_writeoptions();
			return true;
		}
		return false;
	}
	
	function tw_readoptions() {
		$values = $this->options;
		$twOptions = get_option($this->optionsname);
		
		if (!empty($twOptions)) {
			// options from previous save
			foreach ($twOptions as $key => $option) $values[$key] = $option;	
			// new installation?
		} elseif ($values['tw_config_ver']!='1') {
			$bool_options = $this->boolops;
			// options from a previous version?
			if (get_option('tw_count')){
				foreach( $values as $key => $value ) {
					if($tmpvar = (string)get_option($key)){
						$values[$key] = get_option($key);
					}
				}
				foreach($bool_options as $key) {
					if (get_option($key)!='1'){
						update_option($bool_options[$key],'0');
						$values[$key] = '0';
					}
				}
				foreach( $values as $key => $value ) {
					delete_option($key);
				}
				$values['tw_config_ver']='1';
			}
		}

		$this->options=$values;
		$this->tw_writeoptions();
		return $values;
	}

	function tw_get_option($optionname){
		return $this->options[$optionname];
	}	

	function tw_set_option($optionname=null, $value=null){
		$this->options[$optionname]=$value;
	}
	
	function tw_flush_cache(){
		$msg = '';
		if ($_POST['tw_flush_cache']=='1'){
			if (function_exists('w3tc_pgcache_flush')) {
				w3tc_pgcache_flush();
				$msg = __('W3TC Page Cache cleared',$this->txtdom);
				return 'w3';
			} else if (function_exists('wp_cache_clear_cache')) {
				wp_cache_clear_cache();
				$msg = __('WP Super Cache cleared',$this->txtdom);
				return 'sc';
			}
		}
		return false;
	}

	function wpTweetButton(){
		$this->options = $this->tw_readoptions();
		// paranoia
		if (is_admin()){
			add_action('admin_menu', 		array(&$this, 'tw_options'));
			add_action('admin_init', 		array(&$this, 'tw_init'));
			add_action('admin_menu', 		array(&$this, 'tw_tweet_button_post_options_box'));
			add_action('new_to_publish', 	array(&$this, 'tw_post_tweet_button_box_process'));
			add_action('save_post', 		array(&$this, 'tw_post_tweet_button_box_process'));
			$uri=null;
			if($this->tw_updateoptions()){
				$uri='&op1=1';
			}
			$tfcr = $this->tw_flush_cache();
			if  ($tfcr=='w3'){$uri .='&op2=w3';}
			if  ($tfcr=='sc'){$uri .='&op2=sc';}
			if ($uri){
				header('location: options-general.php?page=wp-tweet-button.php' .$uri);
				die;
			}
		}
		add_filter('the_title', array(&$this,'tw_set_placement_ready'), 9);
		add_filter('the_content', array(&$this, 'tw_update'),$this->tw_get_option('tw_hook_prio'));
		add_filter('get_the_excerpt', array(&$this, 'tw_remove_filter'), 9);
		if ($this->tw_get_option('tw_display_excerpt') == '1') add_filter('the_excerpt', array(&$this, 'tw_update'), $this->tw_get_option('tw_hook_prio'));
		add_action('init', array(&$this, 'tw_head'));
		if (function_exists('get_user_meta')){
			add_filter('user_contactmethods',array(&$this, 'tw_add_twitter_contactmethod'),10,1);
		}
	}

	function tw_set_placement_ready($title){
		$this->readyState=true;
		return $title;
	}

	// Remove button from hook
	function tw_remove_filter($content) {
		remove_action('the_content', array(&$this, 'tw_update'),$this->tw_get_option('tw_hook_prio'));
		// if ($this->tw_get_option('tw_display_excerpt') == '1') 
		add_filter('the_content', array(&$this, 'tw_add_content_filter'),$this->tw_get_option('tw_hook_prio'));
		return $content;
	}
	// We gotta go back!
	function tw_add_content_filter ($content){
		add_filter('the_content', array(&$this, 'tw_update'),$this->tw_get_option('tw_hook_prio'));
		return $content;
	}

	// build the link using data tags
	function tw_build_options_data() {
		global $post;
		// again...paranoia
		$button_data_url=null;
		$button_data_related=null;
		$button_data_via=null;
		$button_data_text=null;
		$button_data_lang=null;
		$button_data_count=null;
		$button_data_counturl=null;
		$url = $this->tw_get_long_url(true);
		if ($this->tw_get_option('tw_url_shortener')!='none'){$url=$this->tw_get_short_url();}
		// make data-url
		$button_data_url = 'data-url="' . $url. '"';
		// make data-via or adjust tweet text
		if (function_exists('get_user_meta')){
			if (get_user_meta($post->post_author, 'twitter',true)){
				$viauser = get_user_meta($post->post_author, 'twitter',true);
			} else {
				$viauser = $this->tw_get_option('tw_via');
			}
		} else {
			$viauser = $this->tw_get_option('tw_via');
		}
		if ($viauser && $this->tw_get_option('tw_text_format')=='VIA') {
			$button_data_via = 'data-via="' . $viauser.'"';
		} elseif ($viauser && $this->tw_get_option('tw_text_format')=='RT') {
			$textprefix = 'RT @'.$viauser.' ';} 
		else {
			$textprefix='';
		}
		// make data-text
		if (get_post_meta($post->ID, '_twitterrelated_custom_text', true)){
			$tmptxt= str_replace('%POSTTITLE%', $post->post_title, get_post_meta($post->ID, '_twitterrelated_custom_text', true));
			$tmptxt= str_replace('%BLOGTITLE%', get_bloginfo('name'), $tmptxt);
			$button_data_text = 'data-text="' . $textprefix . htmlspecialchars ($tmptxt) . '"';
		} else {	
			if ($this->tw_get_option('tw_text')=='entry_title') {$button_data_text = 'data-text="' .$textprefix . htmlspecialchars($post->post_title).'"';}
			if ($this->tw_get_option('tw_text')=='page_title') {$button_data_text = 'data-text="' . $textprefix . htmlspecialchars($post->post_title .' - '. get_bloginfo('name')).'"';}
			if ($this->tw_get_option('tw_text')=='blog_title') {$button_data_text = 'data-text="' . $textprefix . htmlspecialchars(get_bloginfo('name')).'"';}
			if ($this->tw_get_option('tw_text')=='custom_title') {
				$ctext = stripslashes($this->tw_get_option('tw_text_custom'));
				$tmptxt= str_replace('%POSTTITLE%', $post->post_title, $ctext);
				$tmptxt= str_replace('%BLOGTITLE%', get_bloginfo('name'), $tmptxt);	
				$button_data_text = 'data-text="' . $textprefix . htmlspecialchars ($tmptxt).'"';
			}
		}
		
		// make data-related - manual or automatic
		if (get_post_meta($post->ID, '_twitterrelated', true)){
				$button_data_related = 'data-related="' . get_post_meta($post->ID, '_twitterrelated', true).'"';
		} elseif (get_post_meta($post->ID, 'twitterrelated', true)){
				$button_data_related = 'data-related="' . get_post_meta($post->ID, 'twitterrelated', true).'"';
		} else {
			if ($this->tw_get_option('tw_rec')) {
				$reldata = $this->tw_get_option('tw_rec');
				if ($this->tw_get_option('tw_rec_desc')) {$reldata .= ':' . $this->tw_get_option('tw_rec_desc');}
				$button_data_related = 'data-related="'.$reldata.'"';				
			}
		}
		// make data-lang
		$button_data_lang = 'data-lang="'.$this->tw_get_option('tw_lang').'"';
		// make data-counturl
		if ($this->tw_get_option('tw_url_samecount')=='1'){
			$button_data_counturl = 'data-counturl="'.$this->tw_get_long_url(false). '"';
		} else {
			$button_data_counturl=null;
		}
		// make data-count
		$button_data_count = 'data-count="'.$this->tw_get_option('tw_count').'"';
		$anchordata = $button_data_url." ".$button_data_related." ".$button_data_via." ".$button_data_text." ".$button_data_lang." ".$button_data_count." ".$button_data_counturl;
		return $anchordata;	
	}
	
	// build the URL parameters
	function tw_build_options($bwdata=false) {
		global $post;
		$url= $this->tw_get_long_url(true);
		if ($bwdata==true && !is_feed()){return false;}
		if ($this->tw_get_option('tw_url_shortener')!='none' && $this->tw_get_option('tw_url_shortener')!=null){$url=$this->tw_get_short_url();}
		if (function_exists('get_user_meta')){
			if (get_user_meta($post->post_author, 'twitter',true)){
				$viauser = get_user_meta($post->post_author, 'twitter',true);
			} else {
				$viauser = $this->tw_get_option('tw_via');
			}
		} else {
			$viauser = $this->tw_get_option('tw_via');
		}
		
		$button = '?url=' . urlencode($url);	
		if ($viauser && $this->tw_get_option('tw_text_format')=='VIA') {
			$button .= '&amp;via=' . $viauser;
		} elseif ($viauser && $this->tw_get_option('tw_text_format')=='RT') {
			$textprefix = 'RT @'.$viauser.' ';} 
		else {
			$textprefix='';
		}
		if (get_post_meta($post->ID, '_twitterrelated_custom_text', true)){
			$tmptxt= str_replace('%POSTTITLE%', $post->post_title, get_post_meta($post->ID, '_twitterrelated_custom_text', true));
			$tmptxt= str_replace('%BLOGTITLE%', get_bloginfo('name'), $tmptxt);
			$button .= '&amp;text=' . urlencode(html_entity_decode($textprefix .$tmptxt));
		} else {	
			if ($this->tw_get_option('tw_text')=='entry_title') {$button .= '&amp;text=' .urlencode($textprefix . $post->post_title);}
			if ($this->tw_get_option('tw_text')=='page_title') {$button .= '&amp;text=' . urlencode($textprefix . $post->post_title .' - '. get_bloginfo('name'));}
			if ($this->tw_get_option('tw_text')=='blog_title') {$button .= '&amp;text=' . urlencode($textprefix . get_bloginfo('name'));}
			if ($this->tw_get_option('tw_text')=='custom_title') {
				$tmptxt= str_replace('%POSTTITLE%', $post->post_title, stripslashes($this->tw_get_option('tw_text_custom')));
				$tmptxt= str_replace('%BLOGTITLE%', get_bloginfo('name'), $tmptxt);	
				$button .= '&amp;text=' . urlencode($textprefix .$tmptxt);
			}
		}
		if (get_post_meta($post->ID, '_twitterrelated', true)){
				$button .= '&amp;related=' . urlencode(get_post_meta($post->ID, '_twitterrelated', true));
		} elseif (get_post_meta($post->ID, 'twitterrelated', true)){
				$button .= '&amp;related=' . urlencode(get_post_meta($post->ID, 'twitterrelated', true));
		} else {
			if ($this->tw_get_option('tw_rec')) {
				$button .= '&amp;related=' . $this->tw_get_option('tw_rec');
				if ($this->tw_get_option('tw_rec_desc')) {$button .= ':' . urlencode($this->tw_get_option('tw_rec_desc'));}
			}
		}
		$button .= '&amp;lang='.$this->tw_get_option('tw_lang');
		$button .= '&amp;count='.$this->tw_get_option('tw_count');
		if ($this->tw_get_option('tw_url_samecount')=='1'){
			$button .= '&amp;counturl='.urlencode($this->tw_get_long_url(false));
		} 
		return $button;
	}

	// Fetch me a URL
	function tw_nav_browse($url, $use_POST_method = false, $POST_data = null) {
	  if(function_exists('wp_remote_request') && function_exists('wp_remote_retrieve_response_code') && function_exists('wp_remote_retrieve_body')) {
		if($use_POST_method == 'POST') {
		  $request_params = array('method' => 'POST', 'body' => $POST_data);
		}
		else {
		  $request_params = array('method' => 'GET');
		}
		$url_request = wp_remote_request($url, $request_params);
		$url_response = wp_remote_retrieve_response_code($url_request);
		if($url_response == 200 || $url_response == '200') {
		  $source = wp_remote_retrieve_body($url_request);
		}
		else {
		  $source = '';
		}
	  } elseif (function_exists('curl_init') && function_exists('curl_exec')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_URL, $url);
			if($use_POST_method == 'POST'){
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $POST_data);
			}
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
			curl_setopt($ch, CURLOPT_TIMEOUT, 3);
			$source = trim(curl_exec($ch));
			if ( curl_errno($ch) != 0 ) {
			  $source = '';
			}
			curl_close($ch);
		} else {
			$source = '';
		}
		return $source;
	}

	// Get me the longurl
	// hook: wp_tweet_button_long_url
	function tw_get_long_url($addtrack=false) {
		global $post;
		$perms=null;
		if ($this->tw_get_option('tw_where') == 'manual') {
			if(empty($post->post_title)) {
				$perms= 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] . $_SERVER['QUERY_STRING'];
			} else {
				$perms = get_permalink($post->ID);
			}
		} elseif($this->tw_get_option('tw_display_front') == '' && is_home()) {
			if(empty($post->post_title)) {
				$perms= 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] . $_SERVER['QUERY_STRING'];
			} else {
				$perms = get_permalink($post->ID);
			}
		} else {
			$perms = get_permalink($post->ID);
		}
		if ($addtrack && $this->tw_get_option('tw_ga_code')) {
			if (strstr($perms,'?')){$prestr='&';} else {$prestr='?';}
			$tmptxt= str_replace('?', '', $this->tw_get_option('tw_ga_code'));
			$tmptxt= str_replace('+', '', $tmptxt);
			$tmptxt= str_replace('%POSTID%', $post->ID, $tmptxt);
			$tmptxt= str_replace('%POSTSLUG%', $post->post_name, $tmptxt);
			$tmptxt= str_replace('%2B', '', $tmptxt);
			$tmptxt= str_replace('%20', '', $tmptxt);
			$perms = $perms .$prestr.$tmptxt;
		}
		$perms = apply_filters('wp_tweet_button_long_url', $perms);
		return $perms;
	}

	// Get me a shorty
	// hook: wp_tweet_button_url
	function tw_get_short_url() {
		global $post;
		$perms = $this->tw_get_long_url(true);
		$perms = trim($perms);
		if($post && get_post_status($post->ID) != 'publish') {return $perms;}
		if($this->tw_get_option('tw_url_shortener') == 'none') {return $perms;}
		if ($this->tw_get_option('tw_url_shortener') == 'tflp' && function_exists('permalink_to_twitter_link')) {
			$fetch_url = permalink_to_twitter_link($perms);
		} elseif ($this->tw_get_option('tw_url_shortener') == 'yourls' && function_exists('wp_ozh_yourls_raw_url')) {
			$fetch_url = wp_ozh_yourls_raw_url();
		}
		if (function_exists('wp_get_shortlink')){
			if ($this->tw_get_option('tw_url_shortener') == 'wordpress'){
				$fetch_url = wp_get_shortlink($post->ID);
			}
		}
		if(!empty($fetch_url)){ 
			return $fetch_url;
		}
		$fetch_url = trim(get_post_meta($post->ID, '_twitterrelated_short_url', true));
		if(!is_null($fetch_url) && md5($perms) == trim(get_post_meta($post->ID, '_twitterrelated_short_url', true))) {
			return $fetch_url;
		}
		$url_more = "";
		$method = 'GET';
		$POST_data = array(); 
		switch ($this->tw_get_option('tw_url_shortener')) {
			case 'tiny':
				$first_url = "http://tinyurl.com/api-create.php?url=".urlencode($perms);
				break;
			case 'snip':
				$first_url = "http://snipr.com/site/getsnip";
				$method = 'POST';
				$POST_data = array( "snipformat" => "simple", "sniplink" => rawurlencode($perms), "snipuser" => $this->tw_get_option('tw_url_shortener_snip_user'), "snipapi" => $this->tw_get_option('tw_url_shortener_snip_key') );
				break;
			case 'cligs':
				$first_url = "http://cli.gs/api/v1/cligs/create?url=".urlencode($perms)."&appid=tweetbtn";
				if ($this->tw_get_option('tw_url_shortener_cligs_key'))
					$first_url .= "&key=".$this->tw_get_option('tw_url_shortener_cligs_key');
				break;
			case 'supr':
				$method = 'GET';
				if(($this->tw_get_option('tw_url_shortener_super_user'))&&($this->tw_get_option('tw_url_shortener_super_key')))
					$first_url = "http://su.pr/api/simpleshorten?url=".urlencode($perms)."&login=".$this->tw_get_option('tw_url_shortener_super_user')."&apiKey=".$this->tw_get_option('tw_url_shortener_super_key')."&version=1.0";
				else 
					$first_url = "http://su.pr/api/simpleshorten?url=".urlencode($perms);
				break;
			case 'jmp':
				if ($this->tw_get_option('tw_url_shortener_bitly_user') && $this->tw_get_option('tw_url_shortener_bitly_key')){
					$first_url = "http://api.j.mp/v3/shorten?version=3&longUrl=".urlencode($perms)."&history=1&login=".$this->tw_get_option('tw_url_shortener_bitly_user')."&apiKey=".$this->tw_get_option('tw_url_shortener_bitly_key')."&format=txt";
				}
				break;
			case 'bitly':
				if ($this->tw_get_option('tw_url_shortener_bitly_user') && $this->tw_get_option('tw_url_shortener_bitly_key')){
					$first_url = "http://api.bit.ly/v3/shorten?version=3&longUrl=".urlencode($perms)."&history=1&login=".$this->tw_get_option('tw_url_shortener_bitly_user')."&apiKey=".$this->tw_get_option('tw_url_shortener_bitly_key')."&format=txt";
				}
				break;
			case 'tinyarrow':
				$first_url = "http://tinyarro.ws/api-create.php?utfpure=1";
				if($this->tw_get_option('tw_url_shortener_tinyarrow_user'))
					$first_url .= "&userid=".$this->tw_get_option('tw_url_shortener_tinyarrow_user');
				$first_url .= "&url=".rawurlencode($perms);
				break;
			case 'tanin':
				$first_url = "http://tanin.nl/s/api-create.php?u=".urlencode($perms);
				break;
			case 'slly':
				$first_url = "http://sl.ly/?module=ShortURL&file=Add&mode=API&url=".urlencode($perms);
				break;
			case 'b2l':
			default:
				$first_url = "http://b2l.me/api.php?alias=&url=".urlencode($perms);
				break;
		}
		$fetch_url = trim($this->tw_nav_browse($first_url, $method, $POST_data));
		if ( !empty( $fetch_url ) ) {
			if (!update_post_meta($post->ID, '_twitterrelated_short_url', $fetch_url)) {
				add_post_meta($post->ID, '_twitterrelated_short_url', $fetch_url);
			}
			if (!update_post_meta($post->ID, '_twitterrelated_short_urlHash', md5($perms))) {
				add_post_meta($post->ID, '_twitterrelated_short_urlHash', md5($perms));
			}
			if(md5($perms) == get_post_meta($post->ID, '_twitterrelated_short_urlHash')) {
			  $fetched_array = get_post_meta($post->ID, '_twitterrelated_short_url');
			  $fetch_url = $fetched_array[0];
			} else {
				update_post_meta($post->ID, '_twitterrelated_short_urlHash', md5($perms));
				update_post_meta($post->ID, '_twitterrelated_short_url', $fetch_url);
				$postmeta_array = get_post_meta($post->ID, '_twitterrelated_short_url');
				$fetch_url = $postmeta_array[0];
			}
		} else {
			$fetch_url = $perms;
		}
		$fetch_url = apply_filters('wp_tweet_button_url', $fetch_url);
		return $fetch_url;
	}

	// Generate me a button, will ya?!
	// Hook : wp_tweet_button
	function tw_generate_button($bwdata=false) {
		$data=null;
		if ($bwdata==true && !is_feed()){
			$data=$this->tw_build_options_data().' ';
		} else {
			$data=null;
		}
		if ($this->tw_get_option('tw_rel_meta')!=''){
			$relstr = 'rel="'.$this->tw_get_option('tw_rel_meta').'" ';
		} else {
			$relstr='';
		}
		if ($this->tw_get_option('tw_align')!='none' && $this->tw_get_option('tw_align')!=null && $this->tw_get_option('tw_align')!=''){
			if ($this->tw_get_option('tw_align')=='right') $alignstr = ';float:right;margin-left:10px;';
			if ($this->tw_get_option('tw_align')=='left') $alignstr = ';float:left;margin-right:10px;';
			if ($this->tw_get_option('tw_align')=='center') $alignstr = ';float:none;margin:0 auto;text-align:center;';
		} else {
			$alignstr='';
		}
		$button = 	'<div class="tw_button" style="' . $this->tw_get_option('tw_style_c') . $alignstr . '">';
		$button .= 	'<a href="http://twitter.com/share'.$this->tw_build_options($bwdata).'" '.$data .$relstr . ' class="twitter-share-button">Tweet</a>';
		$button .= 	'</div>';
		$button = apply_filters( 'wp_tweet_button', $button );
		return $button;
	}
	
	// put the button somewhere
	function tw_update($content) {	
		global $post;
		if (!$this->readyState) return $content;
		if (function_exists("bnc_wptouch_is_mobile")) {		
				if (bnc_wptouch_is_mobile() && $this->tw_get_option('tw_display_mobile')==''){
						return $content;
				}
		}
		if (get_post_meta($post->ID, '_exclude_tweet_button', true)){
			return $content;
		}
		if ($this->tw_get_option('tw_display_feed') == '' && is_feed()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_page') == '' && is_page()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_front') == '' && is_home()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_single') == '' && is_single()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_single') == '' && is_home()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_archive') == '' && is_archive()) {
			return $content;
		}
		if ($this->tw_get_option('tw_display_search') == '' && is_search()) {
			return $content;
		}

		if (is_feed()){
			$button = $this->tw_generate_button();
		} else {
			$button = $this->tw_generate_button($this->tw_get_option('tw_bwdata_attr'));
		}
		$where = 'tw_where';
		if ($this->tw_get_option($where) == 'shortcode') {
			return str_replace('[tweetbutton]', $button, $content);
		} else if ($this->tw_get_option($where) == 'beforeandafter') {
			if ($this->tw_get_option('tw_ex_after_home') && is_home()){
				return $button . $content;
			} else {
				return $button . $content . $button;			
			}
		} else if ($this->tw_get_option($where) == 'before') {
			return $button . $content;
		} else if ($this->tw_get_option($where) == 'after') {
			return $content . $button;
		} else {
			return $content;
		}
		// Hey, you never know!
		return $content;
	}

	// Make me a button, manually
	function tweetbutton($post,$bwdata=false) {
		if (isset($post->ID)){
			if (get_post_meta($post->ID, '_exclude_tweet_button', true)){
				return false;
			}
		}
		if ($this->tw_get_option('tw_where') == 'manual') {
			return $this->tw_generate_button($bwdata);
		} else {
			return false;
		}
	}

	// Put the script for the button in your head
	function tw_head() {
		if ( !is_admin() ) {
		   wp_register_script('twitter-widgets','http://platform.twitter.com/widgets.js',array(),'1.0');
		   wp_enqueue_script('twitter-widgets');
		} else {
			add_action('admin_head',array(&$this,'tw_drawcss_admin'));
		}
	}

	function tw_drawcss_admin(){
			?><style type="text/css">
			#wptweetbutton-mbox-general .inside {margin:0;}
			#wptweetbutton-mbox-general .floatleft180 {width:180px;float:left;}
			#wptweetbutton-mbox-general .floatleft100 {width:100px;float:left;}
			#wptweetbutton-mbox-general .floatleftm10 {float:left;margin-right:10px;margin-top: 4px;}
			#wptweetbutton-mbox-general .tweetbtnc {font-size:100%;display:block;float:left;height:90px;}
			#wptweetbutton-mbox-general .floatlm4 {float:left;margin-top:4px;}
			#wptweetbutton-mbox-general .floatlml2 {margin-left:2px;width:100px;display:block;float:left;}
			#wptweetbutton-mbox-general .floatlmn2 {margin-left:2px;display:block;float:left;}
			#wptweetbutton-mbox-general .pad45 {padding:6px;}
			#wptweetbutton-mbox-general .w99c29c {width: 99%;color: #444;}
			#wptweetbutton-mbox-general .bt1pcs {}
			#wptweetbutton-mbox-general .w150 {width: 150px;}
			#wptweetbutton-mbox-general .twhdata p {margin:6px 0;}
			#wptweetbutton-mbox-general .twhrow label {line-height:15px;font-weight: bold;display: block;}
			#wptweetbutton-mbox-general table {border-bottom:1px solid #E3E3E3;}
			#wptweetbutton-mbox-general tr td .warning {color: #D00;}
			#wptweetbutton-mbox-general tr td input:hover,
			#wptweetbutton-mbox-general tr td textarea:hover {background:#f3f7fa;color:#444}
			#wptweetbutton-mbox-general tr td input:focus,
			#wptweetbutton-mbox-general tr td textarea:focus {background:#EAF2FA;color:#000}
			#wptweetbutton-mbox-general td.twhdata label {}
			#wptweetbutton-mbox-general .twhdata {background: #fff;vertical-align:top;}
			#wptweetbutton-mbox-general .twhrow {background: #f1f1f1;border-bottom: 1px solid #e3e3e3;border-right:1px solid #e3e3e3;width: 115px;}
			#wptweetbutton-mbox-general .twhhlp {background: #f1f1f1; width: 200px;color:#565656;padding:6px;border-left:1px solid #e3e3e3;}
			</style><?php
	}
	
	// Draw me an options page
	function tw_options_page(){
		if( function_exists( 'add_meta_box' )) {
			add_meta_box( 'TweetButtonSettings1', 'General settings', array(&$this, 'tw_options_box'), 'wptweetbutton', 'normal');
			?>
				<div id="wptweetbutton-mbox-general" class="wrap">
					<?php screen_icon('options-general'); ?>
					<h2>WP Tweet Button</h2>
					<?php 
					wp_nonce_field('wptweetbutton-mbox-general');
					wp_nonce_field('closedpostboxes', 'closedpostboxesnonce', false );
					wp_nonce_field('meta-box-order', 'meta-box-order-nonce', false ); 
					?>
					<div id="poststuff" class="metabox-holder">
						<div id="post-body" class="has-sidebar">
							<div id="post-body-content" class="">
								<?php do_meta_boxes('wptweetbutton', 'normal', null); ?>
							</div>
						</div>
						<br class="clear"/>
					</div>
				</div>
			<?php
		}
	}

	// Make me a row
	function tw_row_head($rh,$lfor=""){
	return '
					<th class="twhrow" scope="row" valign="top">
						<label for="'.$lfor.'">
							'.$rh.'
						</label>
					</th>';
	}
	
	// Show me all my options
	function tw_options_box() {
		$msg['w3'] = __('W3 Total Cache page cache has been cleared',$this->txtdom);
		$msg['sc'] = __('WP Super Cache cleared',$this->txtdom);

		if (isset($_GET['op2'])) if ($_GET['op2']=='w3'||$_GET['op2']=='sc') {
			$updmsg = '<p><strong>' . $msg[$_GET['op2']] . '</strong></p>';
		} else {
			$updmsg = null;
		}
		if (isset($_GET['op1'])) if ($_GET['op1']=='1') echo '<div id="message" class="updated fade"><p><strong>' . __('Tweet Button settings have been saved',$this->txtdom) . '</strong></p>'.$updmsg.'</div>';
		
		if (isset($_GET['showdiag'])) if ($_GET['showdiag']=='1') echo '<div id="message" class="updated fade"><pre><strong>' . 'PHP version: ' . phpversion(). '<br />WP Tweet Button configuration: ' .print_r($this->options,true) . '</strong></pre></div>';
		?>
		<form method="post" action="" name="twsettingsform" id="twsettingsform"><?php
			if(function_exists('settings_fields')){
				settings_fields('tw-options');
			} else {
				wp_nonce_field('update-options');
				?>
				<input type="hidden" name="action" value="update" />
				<input type="hidden" name="page_options" value="tw_ex_after_home,tw_hook_prio,tw_rel_meta,tw_display_mobile,tw_url_shortener_tinyarrow_user,tw_url_shortener_bitly_user,tw_align,tw_url_shortener_bitly_key,tw_url_shortener_super_user,tw_url_shortener_super_key,tw_url_shortener_snip_user,tw_url_shortener_snip_key,tw_url_shortener_cligs_key,tw_url_shortener,tw_where,tw_style,tw_style_c,tw_count,tw_display_page,tw_display_front,tw_url_samecount,tw_ga_code,tw_via,tw_flush_cache,tw_bwdata_attr,tw_lang,tw_rec,tw_desc,tw_text,tw_text_custom,tw_text_format,tw_display_excerpt,tw_display_feed,tw_display_archive,tw_display_search,tw_display_single" />
				<?php
			}
		?>
			<div>
				<table style="margin:0" class="form-table">
					<tr class="bt1pcs">
						<td class="twhdata" colspan="3"  style="background: #E3E3E3;border-top:1px solid #CCC;border-bottom:1px solid #CCC;">
							<p class="submit">
								<input style="width:160px" type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
							</p>				
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Display',$this->txtdom));?>
						<td class="twhdata">
							<label for="tw_where"><?php _e('Position',$this->txtdom); ?></label><br />						
							<select name="tw_where" class="w99c29c">
								<option <?php if ($this->tw_get_option('tw_where') == 'before') echo 'selected="selected"'; ?> value="before"><?php _e('Before',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_where') == 'after') echo 'selected="selected"'; ?> value="after"><?php _e('After',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_where') == 'beforeandafter') echo 'selected="selected"'; ?> value="beforeandafter"><?php _e('Before and After',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_where') == 'shortcode') echo 'selected="selected"'; ?> value="shortcode"><?php _e('Shortcode',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_where') == 'manual') echo 'selected="selected"'; ?> value="manual"><?php _e('Manual',$this->txtdom);?></option>
							</select>
							<br class="clear">
							<div class="floatleft180">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_single') == '1') echo 'checked="checked"'; ?> name="tw_display_single" id="tw_display_single" group="tw_display"/>
								<label for="tw_display_single"><?php _e('Posts',$this->txtdom); ?></label>
							</div>
							<div class="floatleft100">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_page') == '1') echo 'checked="checked"'; ?> name="tw_display_page" id="tw_display_page" group="tw_display"/>
								<label for="tw_display_page"><?php _e('Pages',$this->txtdom); ?></label>
							</div>
							<div class="floatleft180" style="clear:left;">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_front') == '1') echo 'checked="checked"'; ?> name="tw_display_front" id="tw_display_front" group="tw_display"/>
								<label for="tw_display_front"><?php _e('Front page (home)',$this->txtdom);?></label>
							</div>
							<div class="floatleft100">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_feed') == '1') echo 'checked="checked"'; ?> name="tw_display_feed" id="tw_display_feed" group="tw_display"/>
								<label for="tw_display_feed"><?php _e('RSS feeds',$this->txtdom);?></label>
							</div>
							<div class="floatleft180" style="clear:left;">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_archive') == '1') echo 'checked="checked"'; ?> name="tw_display_archive" id="tw_display_archive" group="tw_display"/>
								<label for="tw_display_archive"><?php _e('Archives',$this->txtdom);?></label>
							</div>
							<div class="floatleft100">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_search') == '1') echo 'checked="checked"'; ?> name="tw_display_search" id="tw_display_search" group="tw_display"/>
								<label for="tw_display_search"><?php _e('Search',$this->txtdom);?></label>
							</div>
							<div class="floatleft180" style="clear:left;">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_excerpt') == '1') echo 'checked="checked"'; ?> name="tw_display_excerpt" id="tw_display_excerpt" group="tw_display"/>
								<label for="tw_display_excerpt"><?php _e('Excerpts',$this->txtdom);?></label>
							</div>
							<?php
							if (function_exists("bnc_wptouch_is_mobile")) {
							?>
							<div class="floatleft180">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_display_mobile') == '1') echo 'checked="checked"'; ?> name="tw_display_mobile" id="tw_display_mobile" />
								<label for="tw_display_mobile"><?php _e('Mobile (WPTouch)',$this->txtdom); ?></label>
							</div>
							<?php
							}
							?>
							<div class="floatleft180" style="clear:left;">
								<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_ex_after_home') == '1') echo 'checked="checked"'; ?> name="tw_ex_after_home" id="tw_ex_after_home" group="tw_display"/>
								<label for="tw_ex_after_home"><?php _e('No After on Front page',$this->txtdom);?></label>
							</div>
							<br class="clear" />
							<label for="tw_align"><?php _e('Alignment',$this->txtdom); ?></label><br />						
							<select name="tw_align" class="w99c29c">
								<option <?php if ($this->tw_get_option('tw_align') == 'none') echo 'selected="selected"'; ?> value="none"><?php _e('None (Default)',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_align') == 'right') echo 'selected="selected"'; ?> value="right"><?php _e('Right',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_align') == 'left') echo 'selected="selected"'; ?> value="left"><?php _e('Left',$this->txtdom);?></option>
								<option <?php if ($this->tw_get_option('tw_align') == 'center') echo 'selected="selected"'; ?> value="center"><?php _e('Center',$this->txtdom);?></option>
							</select>
						</td>
						<td class="twhdata twhhlp" rowspan="2">
							<p>
								<?php _e('Set your look-and-feel preferences.',$this->txtdom); ?>
							</p>
							<p>
								<?php _e('The <strong>"No After on Front page"</strong> option allows you to use "Before and After" placement and the "Front page" placement but exclude the button from the bottom of posts on the front page.',$this->txtdom); ?>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Tweet Button style',$this->txtdom));?>
						<td class="twhdata">
							<div style="float:left;margin-right:10px;">
							<input type="radio" value="vertical" class="floatleftm10" <?php if ($this->tw_get_option('tw_count') == 'vertical') echo 'checked="checked"'; ?> name="tw_count" id="tw_count_vertical" group="tw_count"/>
							<label for="tw_count_vertical" class="tweetbtnc" style="border-right: 1px solid #E3E3E3;width:70px;background:transparent url('<?php echo WP_PLUGIN_URL; ?>/wp-tweet-button/tweetv.png') no-repeat 0 24px"><?php _e('Vertical',$this->txtdom);?></label>
							</div>
							<div style="float:left;margin-right:10px;">
							<input type="radio" value="horizontal" class="floatleftm10" <?php if ($this->tw_get_option('tw_count') == 'horizontal') echo 'checked="checked"'; ?> name="tw_count" id="tw_count_horizontal" group="tw_count"/>
							<label for="tw_count_horizontal" class="tweetbtnc" style="border-right: 1px solid #E3E3E3;width:120px;background:transparent url('<?php echo WP_PLUGIN_URL; ?>/wp-tweet-button/tweeth.png') no-repeat  0 24px"><?php _e('Horizontal',$this->txtdom);?></label>
							</div>
							<div style="float:left;">
							<input type="radio" value="none" class="floatleftm10" <?php if ($this->tw_get_option('tw_count') == 'none') echo 'checked="checked"'; ?> name="tw_count" id="tw_count_none" group="tw_count" />
							<label for="tw_count_none" class="tweetbtnc" style="width:60px;background:transparent url('<?php echo WP_PLUGIN_URL; ?>/wp-tweet-button/tweetn.png') no-repeat  0 24px"><?php _e('No count',$this->txtdom);?></label>
							</div>
						</td>
					</tr>
					<tr class="bt1pcs">
					<?php 
					if (function_exists('get_user_meta')){
						echo $this->tw_row_head(__('Default Twitter username',$this->txtdom),'tw_via');
					} else {
						echo $this->tw_row_head(__('Twitter username',$this->txtdom),'tw_via');
					}
					?>
					<td class="twhdata">
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_via'); ?>" name="tw_via" id="tw_via" /><br />
						</td>
						<td class="twhdata twhhlp">
							<?php
								if (function_exists('get_user_meta')){?>
								<p>
									<?php _e('Authors can also configure their own Twitter accounts on their <a href="profile.php" title="your profile page">profile</a> page.',$this->txtdom); ?>
								</p>
								<?php
								} ?>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Referral format',$this->txtdom),'tw_text_format');?>
						<td class="twhdata">
							<input class="floatlm4" type="radio" value="VIA" <?php if ($this->tw_get_option('tw_text_format') == 'VIA') echo 'checked="checked"'; ?> name="tw_text_format" id="tw_text_format_via" group="tw_text_format"/>
							<label class="floatlmn2" style="width:160px;" for="tw_text_format_via"><?php _e('{text} {link} via {@user}',$this->txtdom);?></label>
							<input class="floatlm4" type="radio" value="RT" <?php if ($this->tw_get_option('tw_text_format') == 'RT') echo 'checked="checked"'; ?> name="tw_text_format" id="tw_text_format_rt" group="tw_text_format"/>
							<label class="floatlmn2" style="width:150px;" for="tw_text_format_rt"><?php _e('RT {@user} {text} {link}',$this->txtdom);?></label>
						</td>
						<td class="twhdata twhhlp">&nbsp;
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Default Tweet text',$this->txtdom),'tw_text');?>
						<td class="twhdata">
							<input class="" type="radio" value="entry_title" <?php if ($this->tw_get_option('tw_text') == 'entry_title') echo 'checked="checked"'; ?> name="tw_text" id="tw_text_entry_title" group="tw_text"/>
							<label class="" for="tw_text_entry_title"><?php _e('Entry title e.g., "Pictures Of My Cat"',$this->txtdom);?></label><br />
							<input class="" type="radio" value="page_title" <?php if ($this->tw_get_option('tw_text') == 'page_title') echo 'checked="checked"'; ?> name="tw_text" id="tw_text_page_title" group="tw_text"/>
							<label class="" for="tw_text_page_title"><?php _e('Page title e.g., "Pictures of my cat - My Wordpress Blog"',$this->txtdom);?></label><br />
							<input class="" type="radio" value="blog_title" <?php if ($this->tw_get_option('tw_text') == 'blog_title') echo 'checked="checked"'; ?> name="tw_text" id="tw_text_blog_title" group="tw_text"/>
							<label class="" for="tw_text_blog_title"><?php _e('Blog title e.g., "My Wordpress Blog"',$this->txtdom);?></label><br />
							<input class="" type="radio" value="custom_title" onclick="var fnow=document.getElementById('tw_text_custom');fnow.focus();" <?php if ($this->tw_get_option('tw_text') == 'custom_title') echo 'checked="checked"'; ?> name="tw_text" id="tw_text_custom_title" group="tw_text" />
							<label class="" for="tw_text_custom_title" onclick="var fnow=document.getElementById('tw_text_custom');fnow.focus();"><?php _e('Custom text',$this->txtdom);?></label><br />
							<textarea class="pad45" style="font-size: 11px;width:300px" type="text" name="tw_text_custom" id="tw_text_custom" /><?php if ($this->tw_get_option('tw_text_custom')) echo stripslashes($this->tw_get_option('tw_text_custom')); ?></textarea>					
						</td>
						<td class="twhdata twhhlp">
							<p><strong><?php _e('Tags for custom text:',$this->txtdom);?></strong></p>
							<p>
								<code>%POSTTITLE%</code> - <?php _e('The post\'s title.',$this->txtdom);?><br />
								<code>%BLOGTITLE%</code> - <?php _e('The blog\'s name.',$this->txtdom);?>
							</p>
							<p><?php _e('Setting a tweet text for specific posts will override this default selection.',$this->txtdom);?></p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Default recommended Twitter user',$this->txtdom),'tw_rec');?>
						<td class="twhdata">
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_rec'); ?>" name="tw_rec" id="tw_rec" /><br />
							<label for="tw_rec_desc"><?php _e('Description',$this->txtdom);?></label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_rec_desc'); ?>" name="tw_rec_desc" id="tw_rec_desc"/>
							<p><?php _e ('After the user tweets the entry, Twitter will allow the user to follow a recommended users. Set a default recommended user here. You can also recommend Twitter users individually in posts and pages using the Tweet Button options.',$this->txtdom);?></p>
						</td>
						<td class="twhdata twhhlp">
							<p>
								<?php _e ('Twitter recommendations configured in posts override these default settings.',$this->txtdom);?>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Container style',$this->txtdom),'tw_style_c');?>
						<td class="twhdata">
							<input class="pad45 w99c29c" type="text" value="<?php echo htmlspecialchars($this->tw_get_option('tw_style_c')); ?>" name="tw_style_c" id="tw_style_c" />
						</td>
						<td class="twhdata twhhlp" rowspan="1">
							<p><?php _e ('Use the container style box to add additional CSS properties to the DIV surrounding the Tweet Button.',$this->txtdom);?>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Tweet Button language',$this->txtdom),'tw_lang');?>
						<td class="twhdata">
							<select id="tw_lang" name="tw_lang" style="" class="w99c29c">
								<option value="en" <?php if ($this->tw_get_option('tw_lang') == 'en') echo 'selected="selected"'; ?>><?php _e('English',$this->txtdom);?></option> 
								<option value="fr" <?php if ($this->tw_get_option('tw_lang') == 'fr') echo 'selected="selected"'; ?>><?php _e('French',$this->txtdom);?></option> 
								<option value="de" <?php if ($this->tw_get_option('tw_lang') == 'de') echo 'selected="selected"'; ?>><?php _e('German',$this->txtdom);?></option> 
								<option value="es" <?php if ($this->tw_get_option('tw_lang') == 'es') echo 'selected="selected"'; ?>><?php _e('Spanish',$this->txtdom);?></option> 
								<option value="ja" <?php if ($this->tw_get_option('tw_lang') == 'ja') echo 'selected="selected"'; ?>><?php _e('Japanese',$this->txtdom);?></option>
							</select> 
						</td>
						<td class="twhdata twhhlp" rowspan="2">
							<p><?php _e('This is the language that the button will render in on your website.',$this->txtdom);?></p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Rel metatag',$this->txtdom),'tw_rel_meta');?>
						<td class="twhdata">
							<input class="pad45 w99c29c" type="text" value="<?php echo htmlspecialchars($this->tw_get_option('tw_rel_meta')); ?>" name="tw_rel_meta" id="tw_rel_meta" />
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('URL Shortener',$this->txtdom),'tw_url_shortener');?>
						<td class="twhdata" style="border-top:1px solid #fff;">
							<select id="tw_url_shortener" name="tw_url_shortener" style="" class="w99c29c">
								<?php
								$shrtnr = $this->tw_get_option('tw_url_shortener');
								?>
								<option <?php if ($shrtnr == 'none') echo 'selected="selected"'; ?> value="none"><?php _e("None (Default)", $this->txtdom);?></option>
								<?php if (function_exists('wp_get_shortlink')){?><option <?php if ($shrtnr == 'wordpress') echo 'selected="selected"'; ?> value="wordpress">Wordpress 3 shortener function</option><?php } ?>
								<option <?php if ($shrtnr == 'b2l') echo 'selected="selected"'; ?> value="b2l">b2l.me</option>
								<option <?php if ($shrtnr == 'bitly') echo 'selected="selected"'; ?> value="bitly">bit.ly</option>
								<option <?php if ($shrtnr == 'jmp') echo 'selected="selected"'; ?> value="jmp">j.mp</option>
								<option <?php if ($shrtnr == 'cligs') echo 'selected="selected"'; ?> value="cligs">cli.gs</option>
								<option <?php if ($shrtnr == 'snipr.com') echo 'selected="selected"'; ?> value="snip">snipr.com</option>
								<option <?php if ($shrtnr == 'supr') echo 'selected="selected"'; ?> value="supr">su.pr</option>
								<option <?php if ($shrtnr == 'tiny') echo 'selected="selected"'; ?> value="tiny">tinyurl.com</option>
								<?php if (function_exists('permalink_to_twitter_link')){?>
								<option <?php if ($shrtnr == 'tflp') echo 'selected="selected"'; ?> value="tflp">Twitter Friendly Links Plugin</option>
								<?php
								}
								if (function_exists('wp_ozh_yourls_raw_url')){?>
								<option <?php if ($shrtnr == 'yourls') echo 'selected="selected"'; ?> value="yourls">YOURLS Plugin</option>
								<?php
								}
								?>
							</select> <br />
						</td>
						<td class="twhdata twhhlp" rowspan="5" valign="top" style="border-top:1px solid #fff;">
								<p><strong><?php _e('Limitations',$this->txtdom);?></strong><br /><?php _e('If you select a shortener from the list, Twitter will still wrap the shortened URL with its own short URL. (t.co)',$this->txtdom);?></p>
								<p><strong><?php _e('Usernames and API Keys', $this->txtdom);?></strong><br /><?php _e ('Some URL shortening services may require(*) usernames and/or API key. You can configure them here to make use of their functionality.',$this->txtdom);?></p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head('bit.ly / j.mp');?>
						<td class="twhdata">
							<p>
							<label for="tw_url_shortener_bitly_user"><?php _e('Username',$this->txtdom);?></label>*<br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_bitly_user');?>" name="tw_url_shortener_bitly_user" id="tw_url_shortener_bitly_user"/>
							</p>
							<p>
							<label for="tw_url_shortener_bitly_key"><?php _e('API key',$this->txtdom);?>*</label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_bitly_key');?>" name="tw_url_shortener_bitly_key" id="tw_url_shortener_bitly_key"/>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head('snipr');?>
						<td class="twhdata">
							<p>
							<label for="tw_url_shortener_snip_user"><?php _e('Username',$this->txtdom);?></label> *<br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_snip_user');?>" name="tw_url_shortener_snip_user" id="tw_url_shortener_snip_user"/>
							</p>
							<p>
							<label for="tw_url_shortener_snip_key"><?php _e('API key',$this->txtdom);?> *</label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_snip_key');?>" name="tw_url_shortener_snip_key" id="tw_url_shortener_snip_key"/>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head('su.pr');?>
						<td class="twhdata">
							<p>
							<label for="tw_url_shortener_super_user"><?php _e('Username',$this->txtdom);?></label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_super_user');?>" name="tw_url_shortener_super_user" id="tw_url_shortener_super_user"/>
							</p>
							<p>
							<label for="tw_url_shortener_super_key"><?php _e('API key',$this->txtdom);?></label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_super_key');?>" name="tw_url_shortener_super_key" id="tw_url_shortener_super_key"/>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head('cli.gs');?>
						<td class="twhdata">
							<p>
							<label for="tw_url_shortener_cligs_key"><?php _e('API Key',$this->txtdom);?></label><br />
							<input class="pad45 w99c29c" type="text" value="<?php echo $this->tw_get_option('tw_url_shortener_cligs_key');?>" name="tw_url_shortener_cligs_key" id="tw_url_shortener_cligs_key"/>
							</p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<?php echo $this->tw_row_head(__('Advanced',$this->txtdom),'tw_bwdata_attr');?>
						<td class="twhdata" style="border-top:1px solid #ccc;">							
							<label for="tw_hook_prio"><?php _e('Filter hook priority. <span class="warning">Only change this value if you know what you\'re doing!</span> (Default is 75)',$this->txtdom); ?></label><br />
							<select name="tw_hook_prio" id="tw_hook_prio" title="<?php echo $this->tw_get_option('tw_hook_prio');?>" class="w99c29c">
							<option value="75">75 (Default)</option>
							</select>
							<script type="text/javascript">
								jQuery(document).ready(function(){
									var ddl = document.getElementById( 'tw_hook_prio' );
									var theOption = new Option;
									var x;
									var i;
									for(i = 0; i < 74; i++) {
									var theOption = new Option;
										x = i + 1;
										if (x == ddl.title){theOption.selected=true;}
										theOption.text = x;
										theOption.value = x;
										ddl.options[i+1] = theOption;
									}
								});
							</script>							
							<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_bwdata_attr') == '1') echo 'checked="checked"'; ?> name="tw_bwdata_attr" id="tw_bwdata_attr" />
							<label for="tw_bwdata_attr"><?php _e('Build Tweet Button with HTML5 data attributes.',$this->txtdom); ?></label><br />
							<input type="checkbox" value="1" <?php if ($this->tw_get_option('tw_url_samecount') == '1') echo 'checked="checked"'; ?> name="tw_url_samecount" id="tw_url_samecount" />
							<label for="tw_url_samecount"><?php _e('Display the same tweet count across all shorteners.',$this->txtdom); ?></label><br />
							<?php
									if (function_exists('w3tc_pgcache_flush')) {
										?>
												<input <?php if ($this->tw_get_option('tw_flush_cache') == '1') echo 'checked="checked"'; ?> type="checkbox" value="1" name="tw_flush_cache" id="tw_flush_cache" />
												<label for="tw_flush_cache"><?php _e('Clear the W3 Total Cache when I save.',$this->txtdom); ?></label>
												<?php
										} else if (function_exists('wp_cache_clear_cache')) {
										?>
												<input type="checkbox" value="1" name="tw_flush_cache" id="tw_flush_cache" />
												<label <?php if ($this->tw_get_option('tw_flush_cache') == '1') echo 'checked="checked"'; ?> for="tw_flush_cache"><?php _e('Clear the WP Super Cache when I save.',$this->txtdom); ?></label>
												<?php
										}
							?>
							<br />
							<label for="tw_ga_code"><?php _e('Google Analytics campaign tracking code.',$this->txtdom); ?></label><br />
							<?php _e('You can use <code>%POSTID%</code> and <code>%POSTSLUG%</code> in this field but no spaces, no + and no domain names. Simply enter the URL parameters. Example:<br />
							<code>utm_source=twitter&utm_medium=twt&utm_campaign=%POSTSLUG%</code>',$this->txtdom); ?>
							<input class="pad45 w99c29c" type="text" value="<?php echo htmlspecialchars($this->tw_get_option('tw_ga_code')); ?>" name="tw_ga_code" id="tw_ga_code" />
						</td>
						<td style="border-top: 1px solid #fff;border-bottom: 1px solid #CCC;" class="twhdata twhhlp" valign="top" style="">
							<p><strong><?php _e('Filter hook priority',$this->txtdom); ?></strong></p>
							<p><?php _e('Hook priority allows you to change the order in which the button is placed in relation to other plugins. Use 7,8,9 or 10 to get your desired result. Changing this value may break the formatting of the button.',$this->txtdom); ?></p>
						</td>
					</tr>
					<tr class="bt1pcs">
						<td class="twhdata" colspan="3" style="background:#E3E3E3;border-top:1px solid #CCC;border-bottom:1px solid #CCC;">
							<p class="submit">
								<input style="width:160px" type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
							</p>				
						</td>
					</tr>
				</table>
				<br class="clear" />
			</div>
		</form>
		<div style="float:right">
		<form action="https://www.paypal.com/cgi-bin/webscr" method="post"><p><input type="hidden" name="cmd" value="_s-xclick"/><input type="hidden" name="hosted_button_id" value="6228273"/><input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!"/><br /><img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1"/></p></form>
		</div>
		<p style="margin-left:20px;">
			<em><?php echo sprintf(__("Found a bug? Report it <a href='%1\$s' target='_blank'>here</a>."), 'http://0xtc.com/2010/08/13/wordpress-plugin-for-twitters-tweet-button.xhtml');?></em><br />
			<em><?php echo sprintf(__("<a href='%1\$s'>Show settings for diagnostics</a>"), 'options-general.php?page=wp-tweet-button.php&amp;showdiag=1');?></em>
		</p>
		<br class="clear" />
		<?php
	}
	// Save my settings
	function tw_post_tweet_button_box_process($post_ID) {
		$thepost = get_post($post_ID);
		if ($_POST['tw_exclude_tweet_button'] == '1') {
			add_post_meta($thepost->ID, '_exclude_tweet_button', 1, TRUE) or update_post_meta($thepost->ID, '_exclude_tweet_button', 1);
		} elseif ( $_POST['tw_exclude_tweet_button'] == null ) {
			delete_post_meta($thepost->ID, '_exclude_tweet_button');
		}	
		if ($_POST['tw_post_custom_text'] == null) {
			delete_post_meta($thepost->ID, '_twitterrelated_custom_text');
		} else {
			add_post_meta($thepost->ID, '_twitterrelated_custom_text', $_POST['tw_post_custom_text'], TRUE) or update_post_meta($thepost->ID, '_twitterrelated_custom_text', $_POST['tw_post_custom_text']);
		}
		if ($_POST['tw_twitter_related_user'] == null) {
			delete_post_meta($thepost->ID, '_twitterrelated_user');
		} else {
			add_post_meta($thepost->ID, '_twitterrelated_user', $this->tw_sanitize_username($_POST['tw_twitter_related_user']), TRUE) or update_post_meta($thepost->ID, '_twitterrelated_user', $this->tw_sanitize_username($_POST['tw_twitter_related_user']));
		}
		if ($_POST['tw_twitter_related_desc'] == null) {
			delete_post_meta($thepost->ID, '_twitterrelated_desc');
		} else {
			add_post_meta($thepost->ID, '_twitterrelated_desc', $_POST['tw_twitter_related_desc'], TRUE) or update_post_meta($thepost->ID, '_twitterrelated_desc', $_POST['tw_twitter_related_desc']);
		}
		if (($_POST['tw_twitter_related_desc'] != null) && ($_POST['tw_twitter_related_user'] != null)) {
			add_post_meta($thepost->ID, '_twitterrelated', $this->tw_sanitize_username($_POST['tw_twitter_related_user']).':'.$_POST['tw_twitter_related_desc'], TRUE) or update_post_meta($thepost->ID, '_twitterrelated', $this->tw_sanitize_username($_POST['tw_twitter_related_user']).':'.$_POST['tw_twitter_related_desc']);
		} else 	if (($_POST['tw_twitter_related_desc'] == null) && ($_POST['tw_twitter_related_user'] != null)) {
			add_post_meta($thepost->ID, '_twitterrelated', $this->tw_sanitize_username($_POST['tw_twitter_related_user']), TRUE) or update_post_meta($thepost->ID, '_twitterrelated', $this->tw_sanitize_username($_POST['tw_twitter_related_user']));
		} else {
			delete_post_meta($thepost->ID, '_twitterrelated');
		}
	}

	// Show me options for my posts
	function tw_post_tweet_button_box() {
		global $post;
		$tw_exclude_tweet_button = get_post_meta($post->ID,'_exclude_tweet_button',1);
		$tw_twitter_related_user = get_post_meta($post->ID,'_twitterrelated_user',1);
		$tw_twitter_related_desc = get_post_meta($post->ID,'_twitterrelated_desc',1);
		$tw_post_custom_text = get_post_meta($post->ID,'_twitterrelated_custom_text',1);?><script type="text/javascript">
		jQuery(document).ready(function(){
			jQuery('#wpTweetButtonPostOp .head').click(function() {
				jQuery(this).next().slideToggle("slow");
				return false;
			}).next().hide();
		});		
		</script><div id="wpTweetButtonPostOp">
		<h4 class="head" style="font-size: 10pt;margin:0 0 10px 5px"><a href="#"><?php _e('Tweet Button options',$this->txtdom);?></a></h4>
		<div>
			<p style="margin:0;"><?php _e('If this post is related to a Twitter user, the Tweet Button can be enhanced by adding the Twitter account as a recommended user.',$this->txtdom);?></p>
			<div class="misc-pub-section">
				<label for="tw_twitter_related_user" style="width:80px;float:left;padding:5px 0"><?php _e('Username:',$this->txtdom);?></label>
				<input class="pad45" style="width:165px;text-align:left;" type="text" value="<?php echo $tw_twitter_related_user; ?>" name="tw_twitter_related_user" id="tw_twitter_related_user"/> <br />
				<label for="tw_twitter_related_desc" style="width:80px;float:left;padding:5px 0"><?php _e('Description:',$this->txtdom);?></label>
				<input class="pad45" style="width:165px;text-align:left;" type="text" value="<?php echo $tw_twitter_related_desc; ?>" name="tw_twitter_related_desc" id="tw_twitter_related_desc"/> 
			</div>
			<div class="misc-pub-section">
				<p style="margin:0;"><?php _e('Enter an optional custom tweet for this post.',$this->txtdom);?></p>
				<label for="tw_post_custom_text" style="width:80px;float:left;padding:5px 0"><?php _e('Tweet text:',$this->txtdom);?></label>
				<textarea class="pad45" style="width:165px;font-size: 11px;" name="tw_post_custom_text" id="tw_post_custom_text"/><?php echo $tw_post_custom_text; ?></textarea> 
			</div>
			<div class="misc-pub-section">
					<img src="<?php echo WP_PLUGIN_URL; ?>/wp-tweet-button/tweetn.png" id="tw_tweet_button_image" style="float:right;margin:-3px 10px 0 10px"/>
					<input style="min-width:20px;" onclick="var twimgp=document.getElementById('tw_tweet_button_image');twimgp.style.display=(this.checked)?'none':'block';" type="checkbox" value="1" <?php if ($tw_exclude_tweet_button == '1') echo 'checked="checked"'; ?> name="tw_exclude_tweet_button" id="tw_exclude_tweet_button"/>
					<label for="tw_exclude_tweet_button"><?php _e('Disable Tweet Button',$this->txtdom);?></label>
			</div>
		</div></div><br class="clear" /><?php
	}
	
	// Add my options to the posts screens
	function tw_tweet_button_post_options_box() {
		if ( version_compare(get_bloginfo('version'), '2.7', '>=')) {
			add_action('post_submitbox_start', array(&$this, 'tw_post_tweet_button_box'));
		} else {
			add_action('submitpost_box', array(&$this, 'tw_post_tweet_button_box'));
		}
	}

	// Register settings
	function tw_init(){
		if(function_exists('register_setting')){
			register_setting('tw-options', 'wp_tweet_button');
		}
	}

	// Clean up a username
	function tw_sanitize_username($username){
		return preg_replace('/[^A-Za-z0-9_]/','',$username);
	}

	// Release the Kraken!
	function tw_activate(){
		add_option('wp_tweet_button',array());
		$this->tw_readoptions();
	}
	
	// Register the settings page
	function tw_options() {
		add_options_page('WP Tweet Button', 'WP Tweet Button', 8, basename(__FILE__), array(&$this, 'tw_options_page'));
	}

	// Add Twitter to contact options screen for users (WP3 and up)
	function tw_add_twitter_contactmethod($contactmethods ) {
		$contactmethods['twitter'] = 'Twitter';
		return $contactmethods;
	}
}

function tweetbutton($post='',$bwdata=false){
	global $wpTweetButton;
	return $wpTweetButton->tweetbutton($post,$bwdata);
}

$wpTweetButton = new wpTweetButton();
load_plugin_textdomain($wpTweetButton->txtdom,null,dirname( plugin_basename( __FILE__ ) ).'/lang/');
register_activation_hook( __FILE__, array(&$wpTweetButton, 'tw_activate'));
?>